]> git.pld-linux.org Git - packages/rpm-build-tools.git/blame - builder.sh
Move check which branch is active to init_builder
[packages/rpm-build-tools.git] / builder.sh
CommitLineData
10d92f71 1#!/bin/ksh
44058243 2#
dece74ed
AM
3# This program is free software, distributed under the terms of
4# the GNU General Public License Version 2.
5#
cd445739 6# -----------
cd445739 7# Exit codes:
2a5f078d 8# 0 - succesful
9# 1 - help displayed
10# 2 - no spec file name in cmdl parameters
11# 3 - spec file not stored in repo
12# 4 - some source, patch or icon files not stored in repo
13# 5 - package build failed
14# 6 - spec file with errors
15# 7 - wrong source in /etc/poldek.conf
16# 8 - Failed installing buildrequirements and subrequirements
17# 9 - Requested tag already exist
18# 10 - Refused to build fractional release
19# 100 - Unknown error (should not happen)
67963237 20# 110 - Functions not yet implemented
cd445739 21
f8e50be5 22# Notes (todo/bugs):
f8e50be5
ER
23# - when Icon: field is present, -5 and -a5 doesn't work
24# - builder -R skips installing BR if spec is not present before builder invocation (need to run builder twice)
19aa2571 25# - does not respect NoSource: X, and tries to cvs up such files [ example: VirtualBox-bin.spec and its Source0 ]
f8e50be5
ER
26# TODO:
27# - ability to do ./builder -bb foo.spec foo2.spec foo3.spec
1ffcdaff
ER
28# - funny bug, if source-md5 is set then builder will download from distfiles even if there is no url present:
29# Source10: forwardfix.pl
30# # Source10-md5: 8bf85f7368933a4e0cb4f875bac28733
6ca6f876
ZU
31# - builder --help:
32# basename: missing operand
33# Try `basename --help' for more information.
34# -- and the normal usage info --
35
9d99a240
ER
36PROGRAM=${0##*/}
37APPDIR=$(d=$0; [ -L "$d" ] && d=$(readlink -f "$d"); dirname "$d")
cd112f74 38RCSID='$Id: builder,v 1.645 2011/02/13 17:54:10 glen Exp $' r=${RCSID#* * } rev=${r%% *}
b0f031e7 39VERSION="v0.35/$rev"
d43959a2 40VERSIONSTRING="\
b71f5024
ER
41Build package utility from PLD Linux Packages repository
42$VERSION (C) 1999-2011 Free Penguins".
d43959a2 43
d6a77ddb 44PATH="/bin:/usr/bin:/usr/sbin:/sbin:/usr/X11R6/bin"
b03f053b 45
b7cc0c94
ER
46# required rpm-build-macros
47RPM_MACROS_VER=1.534
48
cd445739 49COMMAND="build"
64ea5308 50TARGET=""
cd445739 51
bde1c404 52SPECFILE=""
d287305c 53BE_VERBOSE=""
4003ad8c 54QUIET=""
cd445739
AM
55CLEAN=""
56DEBUG=""
57NOURLS=""
cd445739
AM
58NOCVSSPEC=""
59NODIST=""
47761337 60NOINIT=""
bc10f694 61PREFMIRRORS=""
cd445739 62UPDATE=""
cd445739
AM
63ADD5=""
64NO5=""
65ALWAYS_CVSUP=${ALWAYS_CVSUP:-"yes"}
cd445739 66
6c1b2e7d
PZ
67# use rpm 4.4.6+ digest format instead of comments if non-zero
68USEDIGEST=
69
e3aa6f5e
ER
70# user agent when fetching files
71USER_AGENT="PLD/Builder($VERSION)"
72
cd445739
AM
73# It can be used i.e. in log file naming.
74# See LOGFILE example.
75DATE=`date +%Y-%m-%d_%H-%M-%S`
76
77# Example: LOGFILE='../log.$PACKAGE_NAME'
78# Example: LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
d280fd97 79# Example: LOGFILE='$PACKAGE_NAME/$PACKAGE_NAME.$DATE.log'
f5687002 80# Example: LOGFILE='$PACKAGE_NAME.$DATE.log'
cd445739
AM
81# Yes, you can use variable name! Note _single_ quotes!
82LOGFILE=''
83
84LOGDIR=""
85LOGDIROK=""
86LOGDIRFAIL=""
87LASTLOG_FILE=""
88
89CHMOD="no"
1da227e8 90CHMOD_MODE="0644"
cd445739 91RPMOPTS=""
d1c5a9a7 92RPMBUILDOPTS=""
cd445739
AM
93BCOND=""
94GROUP_BCONDS="no"
ccffa567
ER
95
96# create symlinks for tools in PACKAGE_DIR, see get_spec()
2dd0af86 97SYMLINK_TOOLS="no"
d287305c 98
99PATCHES=""
100SOURCES=""
cd445739 101ICONS=""
d287305c 102PACKAGE_RELEASE=""
103PACKAGE_VERSION=""
104PACKAGE_NAME=""
14bead22 105ASSUMED_NAME=""
fd71d65c 106PROTOCOL="http"
cd445739 107WGET_RETRIES=${MAX_WGET_RETRIES:-0}
cd445739 108
939f2c12 109CVS_FORCE=""
f123bcb5 110CVSIGNORE_DF="yes"
cd445739 111CVSTAG=""
eda17ab7
KK
112GIT_SERVER="git://carme.pld-linux.org"
113GIT_PUSH="draenog@carme.pld-linux.org"
76636346 114PACKAGES_DIR="packages"
a8f917c2 115HEAD_DETACHED=""
3189511a 116DEPTH=""
3f79cb18 117ALL_BRANCHES=""
608c01a7 118REMOTE_PLD="origin"
406b9ecf 119NEW_REPO=""
939f2c12 120
cd445739
AM
121RES_FILE=""
122
cd445739 123DISTFILES_SERVER="://distfiles.pld-linux.org"
d4730dae 124ATTICDISTFILES_SERVER="://attic-distfiles.pld-linux.org"
cd445739 125
36d03934 126DEF_NICE_LEVEL=19
86aafdbe 127SCHEDTOOL="auto"
cd445739
AM
128
129FAIL_IF_NO_SOURCES="yes"
130
18e5347d
ER
131# let get_files skip over files which are present to get those damn files fetched
132SKIP_EXISTING_FILES="no"
133
975d7b23 134TRY_UPGRADE=""
257af81b
ER
135# should the specfile be restored if upgrade failed?
136REVERT_BROKEN_UPGRADE="yes"
137
90baf90b
ER
138if rpm --specsrpm 2>/dev/null; then
139 FETCH_BUILD_REQUIRES_RPMSPECSRPM="yes"
ce40491a 140 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
90baf90b
ER
141else
142 FETCH_BUILD_REQUIRES_RPMSPECSRPM="no"
143 if [ -x /usr/bin/rpm-getdeps ]; then
144 FETCH_BUILD_REQUIRES_RPMGETDEPS="yes"
145 else
146 FETCH_BUILD_REQUIRES_RPMGETDEPS="no"
147 fi
ab4a2b6e
ER
148fi
149
90baf90b 150
cd445739
AM
151# Here we load saved user environment used to
152# predefine options set above, or passed to builder
153# in command line.
154# This one reads global system environment settings:
155if [ -f ~/etc/builderrc ]; then
156 . ~/etc/builderrc
157fi
158# And this one cascades settings using user personal
159# builder settings.
160# Example of ~/.builderrc:
161#
162#UPDATE_POLDEK_INDEXES="yes"
163#FETCH_BUILD_REQUIRES="yes"
164#REMOVE_BUILD_REQUIRES="force"
165#GROUP_BCONDS="yes"
166#LOGFILE='../LOGS/log.$PACKAGE_NAME.$DATE'
982e358c 167#TITLECHANGE=no
cd445739 168#
a83e5405 169SU_SUDO=""
cd445739
AM
170if [ -n "$HOME_ETC" ]; then
171 USER_CFG="$HOME_ETC/.builderrc"
20117088 172 BUILDER_MACROS="$HOME_ETC/.builder-rpmmacros"
cd445739
AM
173else
174 USER_CFG=~/.builderrc
20117088 175 BUILDER_MACROS=~/.builder-rpmmacros
cd445739
AM
176fi
177
178[ -f "$USER_CFG" ] && . "$USER_CFG"
179
86aafdbe
ER
180if [ "$SCHEDTOOL" = "auto" ]; then
181 if [ -x /usr/bin/schedtool ] && schedtool -B -e echo >/dev/null; then
182 SCHEDTOOL="schedtool -B -e"
183 else
184 SCHEDTOOL="no"
185 fi
186fi
187
ca2e6c31 188if [ -n "$USE_PROZILLA" ]; then
7e365483
KK
189 GETURI="proz --no-getch -r -P ./ -t$WGET_RETRIES $PROZILLA_OPTS"
190 GETURI2="$GETURI"
191 OUTFILEOPT="-O"
ca2e6c31 192elif [ -n "$USE_AXEL" ]; then
cede92b3 193 GETURI="axel -a $AXEL_OPTS"
7e365483
KK
194 GETURI2="$GETURI"
195 OUTFILEOPT="-o"
ca2e6c31 196else
5700ee32
ER
197 wget --help 2>&1 | grep -q -- ' --no-check-certificate ' && WGET_OPTS="$WGET_OPTS --no-check-certificate"
198 wget --help 2>&1 | grep -q -- ' --inet ' && WGET_OPTS="$WGET_OPTS --inet"
199 wget --help 2>&1 | grep -q -- ' --retry-connrefused ' && WGET_OPTS="$WGET_OPTS --retry-connrefused"
e3aa6f5e 200 WGET_OPTS="$WGET_OPTS --user-agent=$USER_AGENT"
6f9a5d76 201
7e365483
KK
202 GETURI="wget --passive-ftp -c -nd -t$WGET_RETRIES $WGET_OPTS"
203 GETURI2="wget -c -nd -t$WGET_RETRIES $WGET_OPTS"
204 OUTFILEOPT="-O"
2bc5451f 205fi
11468b23 206
11468b23
AM
207GETLOCAL="cp -a"
208
209if (rpm --version 2>&1 | grep -q '4.0.[0-2]'); then
210 RPM="rpm"
211 RPMBUILD="rpm"
212else
213 RPM="rpm"
214 RPMBUILD="rpmbuild"
215fi
216
c86939e2 217#
218# sanity checks
219#
220if [ -d $HOME/rpm/SOURCES ]; then
221 echo "ERROR: ~/rpm/{SPECS,SOURCES} structure is obsolete" >&2
222 echo "ERROR: get rid of your ~/rpm/SOURCES" >&2
223 exit 1
224fi
225
a8c9a155 226POLDEK_INDEX_DIR="$($RPM --eval %_rpmdir)/"
a83e5405 227POLDEK_CMD="$SU_SUDO /usr/bin/poldek --noask"
11468b23 228
f6711e2a 229run_poldek() {
390d081d 230 RES_FILE=$(tempfile)
cd445739
AM
231 if [ -n "$LOGFILE" ]; then
232 LOG=`eval echo $LOGFILE`
233 if [ -n "$LASTLOG_FILE" ]; then
234 echo "LASTLOG=$LOG" > $LASTLOG_FILE
235 fi
86aafdbe 236 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE})|tee -a $LOG
cd445739
AM
237 return $exit_pldk
238 else
86aafdbe 239 (${NICE_COMMAND} ${POLDEK_CMD} `while test $# -gt 0; do echo "$1 ";shift;done` ; echo $? > ${RES_FILE}) 1>&2 >/dev/null
cd445739
AM
240 return `cat ${RES_FILE}`
241 rm -rf ${RES_FILE}
242 fi
243}
244
cd445739
AM
245#---------------------------------------------
246# functions
da946cd6 247
f6711e2a 248usage() {
cd445739
AM
249 if [ -n "$DEBUG" ]; then set -xv; fi
250 echo "\
3f79cb18 251Usage: builder [--all-branches] [-D|--debug] [-V|--version] [--short-version] [-a|--add_cvs] [-b|-ba|--build]
6594293d 252[-bb|--build-binary] [-bs|--build-source] [-bc] [-bi] [-bl] [-u|--try-upgrade]
0c8e5e9d 253[{-cf|--cvs-force}] [{-B|--branch} <branch>] [--depth <number>]
fd71d65c 254[-g|--get] [-h|--help] [--ftp] [--http] [{-l|--logtofile} <logfile>] [-m|--mr-proper]
ccb03bc0 255[-q|--quiet] [--date <yyyy-mm-dd> [-r <tag>] [{-T|--tag <tag>]
a7b2951c 256[-Tvs|--tag-version-stable] [-Ts|--tag-stable] [-Tv|--tag-version]
b3b584c5 257[{-Tp|--tag-prefix} <prefix>] [{-tt|--test-tag}]
6594293d 258[-nu|--no-urls] [-v|--verbose] [--opts <rpm opts>] [--short-circuit]
3009b80d 259[--show-bconds] [--with/--without <feature>] [--define <macro> <value>]
ccb03bc0 260<package>[.spec][:tag]
2a5f078d 261
cd445739
AM
262-5, --update-md5 - update md5 comments in spec, implies -nd -ncs
263-a5, --add-md5 - add md5 comments to URL sources, implies -nc -nd -ncs
3f79cb18 264--all-branches - make shallow fetch of all branches; --depth required
cd445739 265-n5, --no-md5 - ignore md5 comments in spec
9243e80b
ER
266-D, --debug - enable builder script debugging mode,
267-debug - produce rpm debug package (same as --opts -debug)
d43959a2
ER
268-V, --version - output builder version string
269--short-version - output builder short version
406b9ecf 270-a, --add_vcs - try add new package to PLD repo.
ccb03bc0 271-b, -ba, --build - get all files from PLD repo or HTTP/FTP and build package
cd445739 272 from <package>.spec,
ccb03bc0 273-bb, --build-binary - get all files from PLD repo or HTTP/FTP and build binary
cd445739 274 only package from <package>.spec,
c56807e0 275-bp, --build-prep - execute the %prep phase of <package>.spec,
6594293d
AG
276-bc - execute the %build phase of <package>.spec,
277-bi - execute the %install phase of <package>.spec
278-bl - execute the %files phase of <package>.spec
ccb03bc0 279-bs, --build-source - get all files from PLD repo or HTTP/FTP and only pack
cd445739 280 them into src.rpm,
6594293d 281--short-circuit - short-circuit build
cd445739 282-B, --branch - add branch
387eaf99
ER
283-c, --clean - clean all temporarily created files (in BUILD\$RPM_BUILD_ROOT) after rpmbuild commands.
284 may be used with building process.
6f10b394 285-m, --mr-proper - clean all temporarily created files (in BUILD, SOURCES,
ccb03bc0 286 SPECS and \$RPM_BUILD_ROOT). Doesn't run
6f10b394 287 any rpm building.
ccb03bc0 288-cf, --cvs-force - use -f when tagging
cd445739
AM
289--define <macro> <value>
290 - define a macro <macro> with value <value>,
3189511a
KK
291--depth <number>
292 - make shallow fetch
44058243
ER
293--alt_kernel <kernel>
294 - same as --define 'alt_kernel <kernel>'
cd445739 295--nodeps - rpm won't check any dependences
ccb03bc0 296-g, --get - get <package>.spec and all related files from PLD repo
cd445739
AM
297 or HTTP/FTP,
298-h, --help - this message,
6c5362e5 299-jN, -j N - set %_smp_mflags to propagate concurrent jobs
fd71d65c 300--ftp, --http - use ftp or http protocol to access distfiles server
cd445739
AM
301-l <logfile>, --logtofile <logfile>
302 - log all to file,
cd445739 303-ncs, --no-cvs-specs
ccb03bc0 304 - don't pull from PLD repo
cd445739
AM
305-nd, --no-distfiles - don't download from distfiles
306-nm, --no-mirrors - don't download from mirror, if source URL is given,
307-nu, --no-urls - don't try to download from FTP/HTTP location,
7cbc2d88 308-ns, --no-srcs - don't download Sources/Patches
cd445739
AM
309-ns0, --no-source0 - don't download Source0
310-nn, --no-net - don't download anything from the net
a93e8cdf 311-pm, --prefer-mirrors - prefer mirrors (if any) over distfiles for SOURCES
b572253e 312--no-init - don't initialize builder paths (SPECS and SOURCES)
18e5347d
ER
313-ske,
314--skip-existing-files - skip existing files in get_files
cd445739
AM
315--opts <rpm opts> - additional options for rpm
316-q, --quiet - be quiet,
ccb03bc0
KK
317--date yyyy-mm-dd - build package using resources from specified date,
318-r <tag>, --cvstag <ref>
319 - build package using resources from specified branch/tag,
5053a974 320-A - build package using master branch as any sticky tags/branch/date being reset.
cd445739
AM
321-R, --fetch-build-requires
322 - fetch what is BuildRequired,
323-RB, --remove-build-requires
324 - remove all you fetched with -R or --fetch-build-requires
325 remember, this option requires confirmation,
326-FRB, --force-remove-build-requires
327 - remove all you fetched with -R or --fetch-build-requires
328 remember, this option works without confirmation,
06541433
JR
329-sd, --source-distfiles - list sources available from distfiles (intended for offline
330 operations; does not work when Icon field is present
331 but icon file is absent),
ccb03bc0 332-sc, --source-cvs - list sources available from PLD repo
06541433
JR
333-sdp, --source-distfiles-paths - list sources available from distfiles -
334 paths relative to distfiles directory (intended for offline
335 operations; does not work when Icon field is present
336 but icon file is absent),
a7eefc54 337-sf, --source-files - list sources - bare filenames (intended for offline
338 operations; does not work when Icon field is present
3621e588 339 but icon file is absent),
8bd5e66d 340-lsp, --source-paths - list sources - filenames with full local paths (intended for
a7eefc54 341 offline operations; does not work when Icon field is present
3621e588 342 but icon file is absent),
2dddf439
ER
343-su, --source-urls - list urls - urls to sources and patches
344 intended for copying urls with spec with lots of macros in urls
ccb03bc0
KK
345-T <tag> , --tag <tag>
346 - add git tag <tag> for files,
cd445739 347-Tvs, --tag-version-stable
ccb03bc0 348 - add git tags STABLE and NAME-VERSION-RELEASE for files,
cd445739 349-Ts, --tag-stable
ccb03bc0 350 - add git tag STABLE for files,
cd445739 351-Tv, --tag-version
ccb03bc0 352 - add git tag NAME-VERSION-RELEASE for files,
cd445739
AM
353-Tp, --tag-prefix <prefix>
354 - add <prefix> to NAME-VERSION-RELEASE tags,
355-tt, --test-tag <prefix>
356 - fail if tag is already present,
50321881
JK
357-ir, --integer-release-only
358 - allow only integer and snapshot releases
cd445739
AM
359-v, --verbose - be verbose,
360-u, --try-upgrade - check version, and try to upgrade package
361-un, --try-upgrade-with-float-version
362 - as above, but allow float version
0907f1eb
ER
363 php-pear-Services_Digg/
364--upgrade-version - upgrade to specified version in try-upgrade
deccc50e 365-U, --update - refetch sources, don't use distfiles, and update md5 comments
cd445739
AM
366-Upi, --update-poldek-indexes
367 - refresh or make poldek package index files.
8bd5e66d
ER
368-sp, --skip-patch <patchnumber>
369 - don't apply <patchnumber>. may be repeated.
c890b916 370-np, --nopatch <patchnumber>
8bd5e66d 371 - abort instead of applying patch <patchnumber>
dfe2cb9a
MK
372--show-bconds - show available conditional builds, which can be used
373 - with --with and/or --without switches.
9b78be50
ER
374--show-bcond-args - show active bconds, from ~/.bcondrc. this is used by
375 ./repackage.sh script. in other words, the output is
376 parseable by scripts.
24a97174 377--show-avail-bconds - show available bconds
cd445739
AM
378--with/--without <feature>
379 - conditional build package depending on %_with_<feature>/
380 %_without_<feature> macro switch. You may now use
381 --with feat1 feat2 feat3 --without feat4 feat5 --with feat6
382 constructions. Set GROUP_BCONDS to yes to make use of it.
6dd19291 383--target <platform>, --target=<platform>
3621e588
ER
384 - build for platform <platform>.
385--init-rpm-dir - initialize ~/rpm directory structure
5a491465 386"
387}
388
390d081d
ER
389# create tempfile. as secure as possible
390tempfile() {
391 mktemp -t builder.XXXXXX || ${TMPDIR:-/tmp}/builder.$RANDOM.$$
392}
393
8cc8f5c0
ER
394# inserts git log instead of %changelog
395# outputs name of modified file created by tempfile
396insert_gitlog() {
397 local SPECFILE=$1 specfile=$(tempfile) gitlog=$(tempfile) speclog=$(tempfile)
398
399 # allow this being customized
400 local log_entries=$(rpm -E '%{?_buildchangelogtruncate}')
401
402 # rpm5.org/rpm.org do not parse any other date format than 'Wed Jan 1 1997'
403 # otherwise i'd use --date=iso here
404 # http://rpm5.org/cvs/fileview?f=rpm/build/parseChangelog.c&v=2.44.2.1
405 # http://rpm.org/gitweb?p=rpm.git;a=blob;f=build/parseChangelog.c#l31
406 # NOTE: changelog date is always in UTC for rpmbuild
407 # * 1265749244 +0000 Random Hacker <nikt@pld-linux.org> 9370900
408 git log -${log_entries:-20} --format=format:"* %ad %an <%ae> %h%n%s%n" --date=raw > $gitlog
409 gawk '/^\* /{printf("* %s %s\n", strftime("%a %b %d %Y", $2), substr($0, length($1)+length($2)+length($3)+4)); next}{print}' $gitlog > $speclog
410 sed '/^%changelog/,$d' $SPECFILE | sed -e "\${
411 a%changelog
412 r $speclog
413 }
414 " > $specfile
415 rm -f $gitlog $speclog
416 echo $specfile
417}
418
31d2bd0b
ER
419# change dependency to specname
420# common changes:
421# - perl(Package::Name) -> perl-Package-Name
422depspecname() {
423 local package="$1"
424
560c4b1a 425 package=$(echo "$package" | sed -e '/perl(.*)/{s,perl(\(.*\)),perl-\1,;s,::,-,g};' -e 's/-\(devel\|static\)$//' )
31d2bd0b
ER
426 echo "$package"
427}
428
c890b916 429update_shell_title() {
a0d6396b 430 [ -t 1 ] || return
0b65d15e 431 local len=${COLUMNS:-80}
5c795f16 432 local msg="$(echo "$*" | cut -c-$len)"
0b65d15e 433
e225de91
ER
434 if [ -n "$BE_VERBOSE" ]; then
435 echo >&2 "$(date +%s.%N) $*"
436 fi
437
5c795f16 438 if [ "x$TITLECHANGE" = "xyes" -o "x$TITLECHANGE" = "x" ]; then
138bbc98
ER
439 local pkg
440 if [ -n "$PACKAGE_NAME" ]; then
441 pkg=${PACKAGE_NAME}-${PACKAGE_VERSION}-${PACKAGE_RELEASE}
442 else
443 pkg=${SPECFILE}
444 fi
445
446 msg="$pkg: ${SHELL_TITLE_PREFIX:+$SHELL_TITLE_PREFIX }$msg"
a8c9a155 447 msg=$(echo $msg | tr -d '\n\r')
982e358c
MP
448 case "$TERM" in
449 cygwin|xterm*)
450 echo >&2 -ne "\033]1;$msg\007\033]2;$msg\007"
451 ;;
452 screen*)
453 echo >&2 -ne "\033]0;$msg\007"
454 ;;
455 esac
456 fi
c890b916
ER
457}
458
7e40520f
ER
459# set TARGET from BuildArch: from SPECFILE
460set_spec_target() {
ce40491a 461 if [ -n "$SPECFILE" ] && [ -z "$TARGET" ]; then
b45a3b2a 462 tmp=$(awk '/^BuildArch:/ { print $NF; exit }' $ASSUMED_NAME/$SPECFILE)
ce40491a 463 if [ "$tmp" ]; then
f9109a96 464 target_platform=$(rpm -E '%{_target_vendor}-%{_target_os}%{?_gnu}')
7e40520f
ER
465 TARGET="$tmp"
466 case "$RPMBUILD" in
467 "rpmbuild")
f9109a96 468 TARGET_SWITCH="--target ${TARGET}-${target_platform}" ;;
7e40520f 469 "rpm")
ce40491a 470 TARGET_SWITCH="--target=$TARGET" ;;
7e40520f 471 esac
ce40491a
ER
472 fi
473 fi
7e40520f
ER
474}
475
ace3fd80
ER
476# runs rpm with minimal macroset
477minirpm() {
fa4bf1df 478 # we reset macros not to contain macros.build as all the %() macros are
559d511f 479 # executed here, while none of them are actually needed.
559d511f 480 # at the time of this writing macros.build + macros contained 70 "%(...)" macros.
525bf240 481 safe_macrofiles=$(rpm $TARGET_SWITCH --showrc | awk -F: '/^macrofiles/ { gsub(/^macrofiles[ \t]+:/, "", $0); gsub(/:.*macros.build:/, ":", $0); print $0 } ')
ace3fd80
ER
482
483 # TODO: move these to /usr/lib/rpm/macros
20117088 484 cat > $BUILDER_MACROS <<'EOF'
5b5e5f7f 485%x8664 x86_64 amd64 ia32e
f78a0bb7 486%alt_kernel %{nil}
487%_alt_kernel %{nil}
5ff15c97 488%bootstrap_release() %{1}
407b204b
ER
489%requires_releq_kernel_up(s:n:) %{nil}
490%requires_releq_kernel_smp(s:n:) %{nil}
491%requires_releq_kernel(s:n:) %{nil}
6b8134e3 492%requires_releq() %{nil}
bb01dee9 493%pyrequires_eq() %{nil}
559d511f 494%requires_eq() %{nil}
c13be3d1 495%requires_eq_to() %{nil}
99c05e13 496%requires_ge() %{nil}
500b0eb8
ER
497%requires_ge_to() %{nil}
498%requires_ge() %{nil}
407b204b
ER
499%releq_kernel_up(n:) ERROR
500%releq_kernel_smp(n:) ERROR
501%releq_kernel(n:) ERROR
74d9fd14 502%kgcc_package ERROR
237bd3f1 503%_fontsdir ERROR
7141278d 504%ruby_version ERROR
505%ruby_ver_requires_eq() %{nil}
506%ruby_mod_ver_requires_eq() %{nil}
c13be3d1 507%__php_api_requires() %{nil}
7141278d 508%php_major_version ERROR
509%php_api_version ERROR
99f819cf
AM
510%requires_xorg_xserver_extension %{nil}
511%requires_xorg_xserver_xinput %{nil}
512%requires_xorg_xserver_font %{nil}
513%requires_xorg_xserver_videodrv %{nil}
7141278d 514%py_ver ERROR
41035426
ER
515%perl_vendorarch ERROR
516%perl_vendorlib ERROR
703ae20b
ER
517# damn. need it here! - copied from /usr/lib/rpm/macros.build
518%tmpdir %(echo "${TMPDIR:-/tmp}")
1f28fcb7
ER
519%patchset_source(f:b:) %(
520 base=%{-b*}%{!-b*:10000};
521 start=$(expr $base + %1);
522 end=$(expr $base + %{?2}%{!?2:%{1}});
523 # we need to call seq twice as it doesn't allow two formats
524 seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
525 seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
526 paste %{tmpdir}/__ps{1,2};
527 rm -f %{tmpdir}/__ps{1,2};
528) \
529%{nil}
991f09a5
ER
530%add_etc_shells(p) %{p:<lua>}
531%remove_etc_shells(p) %{p:<lua>}
709995c4
ER
532%lua_add_etc_shells() %{nil}
533%lua_remove_etc_shells() %{nil}
0ca65fa4
JK
534%required_jdk %{nil}
535%buildrequires_jdk %{nil}
f9063abe 536%pear_package_print_optionalpackages %{nil}
fb198857 537EOF
3d12d055 538 if [ "$NOINIT" = "yes" ] ; then
20117088 539 cat >> $BUILDER_MACROS <<'EOF'
3d12d055
JR
540%_specdir ./
541%_sourcedir ./
542EOF
c039643c 543 fi
fff1b991 544 eval $RPMBUILD $TARGET_SWITCH --macros "$safe_macrofiles:$BUILDER_MACROS" $QUIET $RPMOPTS $RPMBUILDOPTS $BCOND $* 2>&1
ace3fd80
ER
545}
546
547cache_rpm_dump() {
548 if [ -n "$DEBUG" ]; then
549 set -x
550 set -v
551 fi
552
d1d24c14 553 if [ -x /usr/bin/rpm-specdump ]; then
525bf240 554 update_shell_title "cache_rpm_dump using rpm-specdump command"
fff1b991 555 rpm_dump_cache=$(rpm-specdump $TARGET_SWITCH $BCOND $SPECFILE)
d1d24c14 556 else
525bf240 557 update_shell_title "cache_rpm_dump using rpmbuild command"
d1d24c14
ER
558 local rpm_dump
559 rpm_dump=`
560 # what we need from dump is NAME, VERSION, RELEASE and PATCHES/SOURCES.
561 dump='%{echo:dummy: PACKAGE_NAME %{name} }%dump'
562 case "$RPMBUILD" in
563 rpm)
564 ARGS='-bp'
565 ;;
566 rpmbuild)
567 ARGS='--nodigest --nosignature --nobuild'
568 ;;
569 esac
570 minirpm $ARGS --define "'prep $dump'" --nodeps $SPECFILE
571 `
572 if [ $? -gt 0 ]; then
573 error=$(echo "$rpm_dump" | sed -ne '/^error:/,$p')
574 echo "$error" >&2
575 Exit_error err_build_fail
576 fi
d05e8080 577
d1d24c14
ER
578 # make small dump cache
579 rpm_dump_cache=`echo "$rpm_dump" | awk '
580 $2 ~ /^SOURCEURL/ {print}
581 $2 ~ /^PATCHURL/ {print}
582 $2 ~ /^nosource/ {print}
583 $2 ~ /^PACKAGE_/ {print}
584 '`
585 fi
d05e8080 586
13974367 587 update_shell_title "cache_rpm_dump: OK!"
cd445739
AM
588}
589
ace3fd80 590rpm_dump() {
cd445739 591 if [ -z "$rpm_dump_cache" ] ; then
45e2a818 592 echo >&2 "internal error: cache_rpm_dump not called! (missing %prep?)"
cd445739
AM
593 fi
594 echo "$rpm_dump_cache"
595}
596
f6711e2a 597get_icons() {
d05e8080 598 update_shell_title "get icons"
9d99a240 599 ICONS=$(awk '/^Icon:/ {print $2}' $PACKAGE_DIR/${SPECFILE})
d05e8080
ER
600 if [ -z "$ICONS" ]; then
601 return
602 fi
603
975d7b23 604 rpm_dump_cache="kalasaba" NODIST="yes" get_files $ICONS
d05e8080
ER
605}
606
f6711e2a 607parse_spec() {
af4d5315 608 update_shell_title "parsing specfile"
cd445739 609 if [ -n "$DEBUG" ]; then
518ff1fb
ER
610 set -x
611 set -v
cd445739 612 fi
b2975fc3 613
d05e8080 614 # icons are needed for successful spec parse
518ff1fb 615 get_icons
d05e8080 616
9c909460 617 cd $PACKAGE_DIR
cd445739 618 cache_rpm_dump
00fcec7e 619
cd445739
AM
620 if (rpm_dump | grep -qEi ":.*nosource.*1"); then
621 FAIL_IF_NO_SOURCES="no"
622 fi
623
7cbc2d88
ER
624 if [ "$NOSRCS" != "yes" ]; then
625 SOURCES=$(rpm_dump | awk '$2 ~ /^SOURCEURL[0-9]+/ {print substr($2, length("SOURCEURL") + 1), $3}' | LC_ALL=C sort -n | awk '{print $2}')
626 PATCHES=$(rpm_dump | awk '$2 ~ /^PATCHURL[0-9]+/ {print substr($2, length("PATCHURL") + 1), $3}' | LC_ALL=C sort -n | awk '{print $2}')
627 ICONS=$(awk '/^Icon:/ {print $2}' ${SPECFILE})
628 fi
629
dfe2b2d9
ER
630 PACKAGE_NAME=$(rpm_dump | awk '$2 == "PACKAGE_NAME" { print $3; exit}')
631 PACKAGE_VERSION=$(rpm_dump | awk '$2 == "PACKAGE_VERSION" { print $3; exit}')
632 PACKAGE_RELEASE=$(rpm_dump | awk '$2 == "PACKAGE_RELEASE" { print $3; exit}')
78eab2a1 633
0b4119a2 634 if [ "$PACKAGE_NAME" != "$ASSUMED_NAME" ]; then
7854d40c 635 echo >&2 "WARNING! Spec name ($ASSUMED_NAME) does not agree with package name ($PACKAGE_NAME)"
0b4119a2
JR
636 fi
637
cd445739
AM
638 if [ -n "$BE_VERBOSE" ]; then
639 echo "- Sources : `nourl $SOURCES`"
640 if [ -n "$PATCHES" ]; then
641 echo "- Patches : `nourl $PATCHES`"
642 else
643 echo "- Patches : *no patches needed*"
644 fi
645 if [ -n "$ICONS" ]; then
646 echo "- Icon : `nourl $ICONS`"
647 else
648 echo "- Icon : *no package icon*"
649 fi
650 echo "- Name : $PACKAGE_NAME"
651 echo "- Version : $PACKAGE_VERSION"
652 echo "- Release : $PACKAGE_RELEASE"
653 fi
13974367
ER
654
655 update_shell_title "parse_spec: OK!"
cd445739
AM
656}
657
f6711e2a 658Exit_error() {
cd445739 659 if [ -n "$DEBUG" ]; then
518ff1fb
ER
660 set -x
661 set -v
cd445739
AM
662 fi
663
664 cd "$__PWD"
665
666 case "$1" in
667 "err_no_spec_in_cmdl" )
668 remove_build_requires
45e2a818 669 echo >&2 "ERROR: spec file name not specified."
cd445739 670 exit 2 ;;
a08d92fc 671 "err_invalid_cmdline" )
45e2a818 672 echo >&2 "ERROR: invalid command line arg ($2)."
a08d92fc 673 exit 2 ;;
cd445739
AM
674 "err_no_spec_in_repo" )
675 remove_build_requires
bba21388 676 echo >&2 "Error: spec file not stored in PLD repo."
cd445739
AM
677 exit 3 ;;
678 "err_no_source_in_repo" )
679 remove_build_requires
bba21388 680 echo >&2 "Error: some source, patch or icon files not stored in PLD repo. ($2)"
cd445739 681 exit 4 ;;
703b6deb 682 "err_cvs_add_failed" )
bba21388 683 echo >&2 "Error: failed to add package to PLD repo."
703b6deb 684 exit 4 ;;
cd445739
AM
685 "err_build_fail" )
686 remove_build_requires
45e2a818 687 echo >&2 "Error: package build failed. (${2:-no more info})"
cd445739 688 exit 5 ;;
78eab2a1
AM
689 "err_no_package_data" )
690 remove_build_requires
45e2a818 691 echo >&2 "Error: couldn't get out package name/version/release from spec file."
78eab2a1 692 exit 6 ;;
ce40491a 693 "err_tag_exists" )
50321881 694 remove_build_requires
d2842af2 695 echo >&2 "Tag ${2} already exists"
50321881 696 exit 9 ;;
ce40491a 697 "err_fract_rel" )
50321881 698 remove_build_requires
45e2a818 699 echo >&2 "Release ${2} not integer and not a snapshot."
50321881 700 exit 10 ;;
fb96e0b5
AM
701 "err_branch_exists" )
702 remove_build_requires
45e2a818 703 echo >&2 "Tree branch already exists (${2})."
fb96e0b5 704 exit 11 ;;
cfc497c0
ER
705 "err_acl_deny" )
706 remove_build_requires
45e2a818 707 echo >&2 "Error: conditions reject building this spec (${2})."
cfc497c0 708 exit 12 ;;
406b9ecf
KK
709 "err_remote_problem" )
710 remove_build_requires
711 echo >&2 "Error: problem with remote (${2})"
712 exit 13 ;;
67963237 713 "err_not_implemented" )
779fcca4 714 remove_build_requires
67963237
KK
715 echo >&2 "Error: functionality not yet imlemented"
716 exit 110 ;;
cd445739 717 esac
45e2a818 718 echo >&2 "Unknown error."
73848362 719 exit 100
cd445739
AM
720}
721
f6711e2a 722init_builder() {
cd445739 723 if [ -n "$DEBUG" ]; then
518ff1fb
ER
724 set -x
725 set -v
0dd6320d 726 fi
cd445739 727
4aeb9973 728 if [ "$NOINIT" != "yes" ] ; then
9c909460 729 TOP_DIR=$(eval $RPM $RPMOPTS --eval '%{_topdir}')
b7cc0c94 730
09bf17c9 731 local macros_ver=$(rpm -E %?rpm_build_macros)
b7cc0c94
ER
732 if [ -z "$macros_ver" ]; then
733 REPO_DIR=$TOP_DIR/packages
734 PACKAGE_DIR=$TOP_DIR/packages/$ASSUMED_NAME
735 else
736 if awk "BEGIN{exit($macros_ver>=$RPM_MACROS_VER)}"; then
737 echo >&2 "builder requires rpm-build-macros >= $RPM_MACROS_VER"
738 exit 1
739 fi
740 REPO_DIR=$TOP_DIR
741 PACKAGE_DIR=$REPO_DIR/$ASSUMED_NAME
742 fi
29e90b02 743 else
9c909460
AM
744 REPO_DIR="."
745 PACKAGE_DIR="."
29e90b02 746 fi
52f3ced3
KK
747 export GIT_WORK_TREE=$PACKAGE_DIR
748 export GIT_DIR=$PACKAGE_DIR/.git
cd445739 749
a095de80
KK
750 if [ -d "$GIT_DIR" ] && [ -z "$CVSTAG" ]; then
751 if CVSTAG=$(GIT_DIR=$GIT_DIR git symbolic-ref HEAD) 2>/dev/null; then
752 CVSTAG=${CVSTAG#refs/heads/}
753 if [ "$CVSTAG" != "master" ]; then
754 echo >&2 "builder: Active branch $CVSTAG. Use -r BRANCHNAME to override"
755 fi
756 else
757 echo >&2 "On detached HEAD. Use -r BRANCHNAME to override"
758 HEAD_DETACHED="yes"
759 fi
760 elif [ "$CVSTAG" = "HEAD" ]; then
761 # assume -r HEAD is same as -A
762 CVSTAG="master"
763 fi
764
a8c9a155 765 __PWD=$(pwd)
00fcec7e 766}
767
406b9ecf
KK
768create_git_repo() {
769 update_shell_title "add_package"
770
771 if [ -n "$DEBUG" ]; then
772 set -x
773 set -v
774 fi
775
776 cd "$REPO_DIR"
777 SPECFILE=$(basename $SPECFILE)
778 if [ ! -f "$ASSUMED_NAME/$SPECFILE" ]; then
779 echo "ERROR: No package to add ($ASSUMED_NAME/$SPECFILE)" >&2
780 exit 101
781 fi
782 [ -d "$ASSUMED_NAME/.git" ] || NEW_REPO=yes
eda17ab7 783 # ssh $GIT_SERVER create ${ASSUMED_NAME} || Exit_error err_cvs_add_failed
406b9ecf 784 git init
eda17ab7
KK
785 git remote add $REMOTE_PLD ${GIT_SERVER}/${PACKAGES_DIR}/${ASSUMED_NAME}.git && \
786 git remote set-url --push $REMOTE_PLD ssh://${GIT_PUSH}/${PACKAGES_DIR}/${ASSUMED_NAME} \
787 || Exit_error err_remote_problem $REMOTE_PLD
406b9ecf
KK
788}
789
f6711e2a 790get_spec() {
c890b916 791
2e5be021 792 update_shell_title "get_spec"
c890b916 793
cd445739 794 if [ -n "$DEBUG" ]; then
518ff1fb
ER
795 set -x
796 set -v
cd445739
AM
797 fi
798
9c909460
AM
799 cd "$REPO_DIR"
800 if [ ! -f "$ASSUMED_NAME/$SPECFILE" ]; then
6277f15f
ER
801 # XXX: still needed?
802 SPECFILE=$(basename $SPECFILE)
cd445739 803 fi
cd445739 804
1ef6f5de 805 if [ "$NOCVSSPEC" != "yes" ]; then
3189511a
KK
806 if [ -z "$DEPTH" ]; then
807 if [ -d "$ASSUMED_NAME/.git" ]; then
608c01a7 808 git fetch $REMOTE_PLD || Exit_error err_no_spec_in_repo
3189511a
KK
809 elif [ "$ADD_PACKAGE_CVS" = "yes" ]; then
810 if [ ! -r "$ASSUMED_NAME/$SPECFILE" ]; then
811 echo "ERROR: No package to add ($ASSUMED_NAME/$SPECFILE)" >&2
812 exit 101
813 fi
814 Exit_error err_not_implemented
815 else
816 (
817 unset GIT_WORK_TREE
eda17ab7 818 git clone -o $REMOTE_PLD ${GIT_SERVER}/${PACKAGES_DIR}/${ASSUMED_NAME}.git || {
588cb3a9 819 # softfail if new package, i.e not yet added to PLD rep
3189511a
KK
820 [ ! -f "$ASSUMED_NAME/$SPECFILE" ] && Exit_error err_no_spec_in_repo
821 echo "Warning: package not in CVS - assuming new package"
822 NOCVSSPEC="yes"
823 }
eda17ab7 824 git remote set-url --push $REMOTE_PLD ssh://${GIT_PUSH}/${PACKAGES_DIR}/${ASSUMED_NAME}
3189511a 825 )
703b6deb 826 fi
9c909460 827 else
3189511a
KK
828 if [ ! -d "$ASSUMED_NAME/.git" ]; then
829 if [ ! -d "$ASSUMED_NAME" ]; then
830 mkdir $ASSUMED_NAME
831 fi
832 git init
76636346 833 git remote add $REMOTE_PLD ${GIT_SERVER}:${PACKAGES_DIR}/${ASSUMED_NAME}.git
6a9f8358 834 CVSTAG=${CVSTAG:-"master"}
3189511a 835 fi
3f79cb18
KK
836 local refs=''
837 if [ -z "$ALL_BRANCHES" ]; then
838 refs="${CVSTAG}:remotes/${REMOTE_PLD}/${CVSTAG}"
839 fi
840 git fetch $DEPTH $REMOTE_PLD $refs || {
3189511a
KK
841 echo >&2 "Error: branch $CVSTAG does not exist"
842 exit 3
843 }
703b6deb 844 fi
0c3beb90 845
0d494abd 846 cvsignore_df .gitignore
703b6deb 847
588cb3a9 848 # add default log format to .gitignore if it is relative to package dir
703b6deb
ER
849 if [ -n "$LOGFILE" -a "$LOGFILE" = "${LOGFILE##*/}" ]; then
850 # substitute known "macros" to glob
851 local logfile=$(echo "$LOGFILE" | sed -e 's,\$\(PACKAGE_NAME\|DATE\),*,g')
852 if [ "$logfile" ]; then
853 cvsignore_df "$logfile"
daeab113 854 fi
9c909460 855 fi
703b6deb
ER
856
857 # create symlinks for tools
858 if [ "$SYMLINK_TOOLS" != "no" ]; then
f3dcc3e7 859 for a in dropin md5 adapter builder {relup,compile,repackage,pearize}.sh pldnotify.awk; do
703b6deb
ER
860 [ -f $a ] || continue
861 ln -sf ../$a $ASSUMED_NAME
862 cvsignore_df $a
863 done
864 fi
cd445739 865 fi
049ab214 866
b0121b45 867 if [ -n "$CVSTAG" ]; then
608c01a7 868 git checkout "$CVSTAG" -- 2>/dev/null || git checkout -t "${REMOTE_PLD}/$CVSTAG" > /dev/null || exit
52f3ced3
KK
869 git symbolic-ref -q HEAD > /dev/null &&
870 git merge '@{u}'
52020f4c 871 if [ -n "$CVSDATE" ]; then
c4c0f339
KK
872 git checkout $(git rev-list -n1 --before="'$CVSDATE'" $CVSTAG) || exit 1
873 fi
b0121b45
KK
874 fi
875
9c909460 876 if [ ! -f "$ASSUMED_NAME/$SPECFILE" ]; then
518ff1fb 877 Exit_error err_no_spec_in_repo
cd445739
AM
878 fi
879
880 if [ "$CHMOD" = "yes" -a -n "$SPECFILE" ]; then
9c909460 881 chmod $CHMOD_MODE $ASSUMED_NAME/$SPECFILE
cd445739
AM
882 fi
883 unset OPTIONS
9c909460 884 [ -n "$DONT_PRINT_REVISION" ] || grep -E -m 1 "^#.*Revision:.*Date" $ASSUMED_NAME/$SPECFILE
7e40520f 885
ce40491a 886 set_spec_target
cd445739
AM
887}
888
f6711e2a 889find_mirror() {
9c909460 890 cd "$REPO_DIR"
782518da 891 local url="$1"
3526abd9 892 if [ ! -f "mirrors" ] ; then
b06a1bd9 893 ln -s rpm-build-tools/mirrors .
cd445739
AM
894 fi
895
896 IFS="|"
782518da
ER
897 local origin mirror name rest ol prefix
898 while read origin mirror name rest; do
899 # skip comments and empty lines
2faa4c32 900 if [ -z "$origin" ] || [ "${origin#\#}" != "$origin" ]; then
782518da
ER
901 continue
902 fi
a8c9a155
ER
903 ol=$(echo -n "$origin" | wc -c)
904 prefix=$(echo -n "$url" | head -c $ol)
cd445739 905 if [ "$prefix" = "$origin" ] ; then
a8c9a155 906 suffix=$(echo "$url" | cut -b $((ol+1))-)
cd445739
AM
907 echo -n "$mirror$suffix"
908 return 0
909 fi
910 done < mirrors
911 echo "$url"
912}
913
e7e0d4ec 914# Warning: unpredictable results if same URL used twice
f6711e2a 915src_no() {
9c909460 916 cd $PACKAGE_DIR
cd445739
AM
917 rpm_dump | \
918 grep "SOURCEURL[0-9]*[ ]*$1""[ ]*$" | \
919 sed -e 's/.*SOURCEURL\([0-9][0-9]*\).*/\1/' | \
920 head -n 1 | xargs
1471f6d6 921}
922
f6711e2a 923src_md5() {
e7e0d4ec 924 [ "$NO5" = "yes" ] && return
cd445739
AM
925 no=$(src_no "$1")
926 [ -z "$no" ] && return
9c909460 927 cd $PACKAGE_DIR
e7e0d4ec
ER
928 local md5
929
930 if [ -f additional-md5sums ]; then
e7e0d4ec 931 md5=$(grep -s -v '^#' additional-md5sums | \
9413a514 932 grep -E "[ ]$(basename "$1")([ ,]|\$)" | \
e7e0d4ec
ER
933 sed -e 's/^\([0-9a-f]\{32\}\).*/\1/' | \
934 grep -E '^[0-9a-f]{32}$')
935
936 if [ "$md5" ]; then
937 if [ $(echo "$md5" | wc -l) != 1 ] ; then
938 echo "$SPECFILE: more then one entry in additional-md5sums for $1" 1>&2
939 fi
940 echo "$md5" | tail -n 1
941 return
942 fi
cd445739 943 fi
e7e0d4ec 944
657d488b 945 source_md5=`grep -i "^#[ ]*Source$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
e7e0d4ec
ER
946 if [ -n "$source_md5" ]; then
947 echo $source_md5
cd445739 948 else
7805dcb4
PZ
949 source_md5=`grep -i "BuildRequires:[ ]*digest(%SOURCE$no)[ ]*=" $SPECFILE | sed -e 's/.*=//'`
950 if [ -n "$source_md5" ]; then
951 echo $source_md5
952 else
953 # we have empty SourceX-md5, but it is still possible
954 # that we have NoSourceX-md5 AND NoSource: X
657d488b 955 nosource_md5=`grep -i "^#[ ]*NoSource$no-md5[ ]*:" $SPECFILE | sed -e 's/.*://'`
7805dcb4
PZ
956 if [ -n "$nosource_md5" -a -n "`grep -i "^NoSource:[ ]*$no$" $SPECFILE`" ] ; then
957 echo $nosource_md5
958 fi
cd445739 959 fi
cd445739
AM
960 fi
961}
962
f6711e2a 963distfiles_path() {
06541433
JR
964 echo "by-md5/$(src_md5 "$1" | sed -e 's|^\(.\)\(.\)|\1/\2/&|')/$(basename "$1")"
965}
966
f6711e2a 967distfiles_url() {
06541433 968 echo "$PROTOCOL$DISTFILES_SERVER/distfiles/$(distfiles_path "$1")"
cd445739
AM
969}
970
f6711e2a 971distfiles_attic_url() {
06541433 972 echo "$PROTOCOL$ATTICDISTFILES_SERVER/distfiles/Attic/$(distfiles_path "$1")"
cd445739
AM
973}
974
f6711e2a 975good_md5() {
cd445739
AM
976 md5=$(src_md5 "$1")
977 [ "$md5" = "" ] || \
978 [ "$md5" = "$(md5sum $(nourl "$1") 2> /dev/null | sed -e 's/ .*//')" ]
8ba5cdda
PG
979}
980
f6711e2a 981good_size() {
a8c9a155 982 size=$(find $(nourl "$1") -printf "%s" 2>/dev/null)
ce40491a 983 [ -n "$size" -a "$size" -gt 0 ]
a4b50627
AF
984}
985
f6711e2a 986cvsignore_df() {
947025e5 987 if [ "$CVSIGNORE_DF" != "yes" ]; then
988 return
989 fi
0d494abd 990 cvsignore=${PACKAGE_DIR}/.gitignore
7dc8d095
ER
991
992 # add only if not yet there
aa189b05 993 if ! awk -vf="$1" -vc=1 '$0 == f { c = 0 } END { exit c }' $cvsignore 2>/dev/null; then
947025e5 994 echo "$1" >> $cvsignore
995 fi
996}
997
71f8e908 998# returns true if "$1" is ftp, http or https protocol url
f6711e2a 999is_url() {
71f8e908
ER
1000 case "$1" in
1001 ftp://*|http://*|https://*)
1002 return 0
1003 ;;
1004 esac
1005 return 1
1006}
1007
f6711e2a 1008update_md5() {
ecba6ad5
ER
1009 if [ $# -eq 0 ]; then
1010 return
1011 fi
1012
1013 update_shell_title "update md5"
1014 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1015 set -x
1016 set -v
ecba6ad5
ER
1017 fi
1018
9c909460 1019 cd "$PACKAGE_DIR"
ecba6ad5
ER
1020
1021 # pass 1: check files to be fetched
1022 local todo
1023 local need_files
1024 for i in "$@"; do
1025 local fp=$(nourl "$i")
1026 local srcno=$(src_no "$i")
6392b5fd
ER
1027 if [ -n "$ADD5" ]; then
1028 [ "$fp" = "$i" ] && continue # FIXME what is this check doing?
9c909460
AM
1029 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE && continue
1030 grep -qiE '^BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE && continue
6392b5fd 1031 else
9c909460 1032 grep -qiE '^#[ ]*Source'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE || grep -qiE '^BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE || continue
ecba6ad5
ER
1033 fi
1034 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
1035 need_files="$need_files $i"
1036 fi
1037 done
1038
1039 # pass 1a: get needed files
1040 if [ "$need_files" ]; then
1041 get_files $need_files
1042 fi
1043
1044 # pass 2: proceed with md5 adding or updating
1045 for i in "$@"; do
1046 local fp=$(nourl "$i")
1047 local srcno=$(src_no "$i")
9c909460 1048 local md5=$(grep -iE '^#[ ]*(No)?Source'$srcno'-md5[ ]*:' $PACKAGE_DIR/$SPECFILE )
e19ad799 1049 if [ -z "$md5" ]; then
9c909460 1050 md5=$(grep -iE '^[ ]*BuildRequires:[ ]*digest[(]%SOURCE'$srcno'[)][ ]*=' $PACKAGE_DIR/$SPECFILE )
6c1b2e7d 1051 fi
71f8e908 1052 if [ -n "$ADD5" ] && is_url $i || [ -n "$md5" ]; then
6c1b2e7d 1053 local tag="# Source$srcno-md5:\t"
71f8e908 1054 if [[ "$md5" == *NoSource* ]]; then
6c1b2e7d
PZ
1055 tag="# NoSource$srcno-md5:\t"
1056 elif [ -n "$USEDIGEST" ]; then
1057 tag="BuildRequires:\tdigest(%SOURCE$srcno) = "
71f8e908 1058 fi
ecba6ad5 1059 md5=$(md5sum "$fp" | cut -f1 -d' ')
15bf3e99 1060 echo "Updating Source$srcno ($md5: $fp)."
ecba6ad5 1061 perl -i -ne '
6c1b2e7d
PZ
1062 print unless (/^\s*#\s*(No)?Source'$srcno'-md5\s*:/i or /^\s*BuildRequires:\s*digest\(%SOURCE'$srcno'\)/i);
1063 print "'"$tag$md5"'\n" if /^Source'$srcno'\s*:\s+/;
ecba6ad5 1064 ' \
9c909460 1065 $PACKAGE_DIR/$SPECFILE
ecba6ad5
ER
1066 fi
1067 done
1068}
1069
f6711e2a 1070check_md5() {
60499e54 1071 local bad
3fbff8b8
ER
1072 [ "$NO5" = "yes" ] && return
1073
ecba6ad5
ER
1074 update_shell_title "check md5"
1075
1076 for i in "$@"; do
60499e54
AM
1077 bad=0
1078 if ! good_md5 "$i"; then
1079 echo -n "MD5 sum mismatch."
1080 bad=1
1081 fi
1082 if ! good_size "$i"; then
1083 echo -n "0 sized file."
1084 bad=1
ecba6ad5
ER
1085 fi
1086
60499e54
AM
1087 if [ $bad -eq 1 ]; then
1088 echo " Use -U to refetch sources,"
1089 echo "or -5 to update md5 sums, if you're sure files are correct."
1090 Exit_error err_no_source_in_repo $i
1091 fi
ecba6ad5
ER
1092 done
1093}
1094
f6711e2a 1095get_files() {
7cb24972 1096 update_shell_title "get_files"
cd445739
AM
1097
1098 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1099 set -x
1100 set -v
cd445739
AM
1101 fi
1102
f09c0772 1103 if [ $# -gt 0 ]; then
9c909460 1104 cd "$PACKAGE_DIR"
cd445739 1105
f2e42a41 1106 local nc=0
e7fa3b9f 1107 local get_files_cvs=""
3815b69a 1108 for i in "$@"; do
f2e42a41 1109 nc=$((nc + 1))
dcebdffb 1110 local cvsup=0
3815b69a 1111 SHELL_TITLE_PREFIX="get_files[$nc/$#]"
f2e42a41 1112 update_shell_title "$i"
f09c0772 1113 local fp=`nourl "$i"`
ecba6ad5 1114 if [ "$SKIP_EXISTING_FILES" = "yes" ] && [ -f "$fp" ]; then
ce40491a 1115 continue
18e5347d 1116 fi
ecba6ad5 1117
cd445739 1118 FROM_DISTFILES=0
e7e0d4ec 1119 local srcmd5=$(src_md5 "$i")
ecba6ad5
ER
1120
1121 # we know if source/patch is present in cvs/distfiles
1122 # - has md5 (in distfiles)
1123 # - in cvs... ideas?
1124
1125 # CHECK: local file didn't exist or always cvs up (first) requested.
f09c0772 1126 if [ ! -f "$fp" ] || [ $ALWAYS_CVSUP = "yes" ]; then
cd445739
AM
1127 if echo $i | grep -vE '(http|ftp|https|cvs|svn)://' | grep -qE '\.(gz|bz2)$']; then
1128 echo "Warning: no URL given for $i"
1129 fi
08908161 1130 target="$fp"
cd445739 1131
e7e0d4ec 1132 if [ -z "$NODIST" ] && [ -n "$srcmd5" ]; then
a4b50627 1133 if good_md5 "$i" && good_size "$i"; then
e7e0d4ec 1134 echo "$fp having proper md5sum already exists"
cd445739
AM
1135 continue
1136 fi
28b34560 1137
bc10f694 1138 # optionally prefer mirror over distfiles if there's mirror
28b34560 1139 # TODO: build url list and then try each url from the list
bc10f694 1140 if [ -n "$PREFMIRRORS" ] && [ -z "$NOMIRRORS" ] && im=$(find_mirror "$i") && [ "$im" != "$i" ]; then
28b34560
ER
1141 url="$im"
1142 else
1143 url=$(distfiles_url "$i")
1144 fi
1145
cd445739
AM
1146 url_attic=$(distfiles_attic_url "$i")
1147 FROM_DISTFILES=1
ecba6ad5
ER
1148 # is $url local file?
1149 if [[ "$url" = [./]* ]]; then
18a52930 1150 update_shell_title "${GETLOCAL%% *}: $url"
cd445739
AM
1151 ${GETLOCAL} $url $target
1152 else
1153 if [ -z "$NOMIRRORS" ]; then
9e9f8920 1154 url=$(find_mirror "$url")
cd445739 1155 fi
9e9f8920
ER
1156
1157 local uri=${url}
1158 # make shorter message for distfiles urls
1159 if [[ "$uri" = ${PROTOCOL}${DISTFILES_SERVER}* ]] || [[ "$uri" = ${PROTOCOL}${ATTICDISTFILES_SERVER}* ]]; then
1160 uri=${uri#${PROTOCOL}${DISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
1161 uri=${uri#${PROTOCOL}${ATTICDISTFILES_SERVER}/distfiles/by-md5/?/?/*/}
1162 uri="df: $uri"
1163 fi
1164 update_shell_title "${GETURI%% *}: $uri"
ca2e6c31 1165 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 1166 if [ "`echo $url | grep -E 'ftp://'`" ]; then
18a52930 1167 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 1168 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739
AM
1169 fi
1170 fi
ecba6ad5
ER
1171
1172 # is it empty file?
1173 if [ ! -s "$target" ]; then
cd445739
AM
1174 rm -f "$target"
1175 if [ `echo $url_attic | grep -E '^(\.|/)'` ]; then
18a52930 1176 update_shell_title "${GETLOCAL%% *}: $url_attic"
cd445739
AM
1177 ${GETLOCAL} $url_attic $target
1178 else
1179 if [ -z "$NOMIRRORS" ]; then
a8c9a155 1180 url_attic=$(find_mirror "$url_attic")
cd445739 1181 fi
18a52930 1182 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 1183 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 1184 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 1185 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 1186 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739 1187 fi
1cd7fc57 1188 test -s "$target" || rm -f "$target"
cd445739
AM
1189 fi
1190 fi
ecba6ad5
ER
1191
1192 if [ -s "$target" ]; then
947025e5 1193 cvsignore_df $target
1194 else
cd445739
AM
1195 rm -f "$target"
1196 FROM_DISTFILES=0
1197 fi
cd445739
AM
1198 fi
1199
f09c0772 1200 if [ -z "$NOURLS" ] && [ ! -f "$fp" -o -n "$UPDATE" ] && [ "`echo $i | grep -E 'ftp://|http://|https://'`" ]; then
cd445739 1201 if [ -z "$NOMIRRORS" ]; then
a8c9a155 1202 im=$(find_mirror "$i")
cd445739
AM
1203 else
1204 im="$i"
1205 fi
ce40491a 1206 update_shell_title "${GETURI%% *}: $im"
08908161 1207 ${GETURI} "$im" ${OUTFILEOPT} "$target" || \
33da77c4 1208 if [ "`echo $im | grep -E 'ftp://'`" ]; then
ce40491a 1209 update_shell_title "${GETURI2%% *}: $im"
08908161 1210 ${GETURI2} "$im" ${OUTFILEOPT} "$target"
7e365483 1211 fi
1cd7fc57 1212 test -s "$target" || rm -f "$target"
cd445739
AM
1213 fi
1214
dcebdffb
ER
1215 if [ "$cvsup" = 1 ]; then
1216 continue
1217 fi
1218
cd445739 1219 fi
ecba6ad5
ER
1220
1221 # the md5 check must be moved elsewhere as if we've called from update_md5 the md5 is wrong.
f09c0772 1222 if [ ! -f "$fp" -a "$FAIL_IF_NO_SOURCES" != "no" ]; then
b3b584c5 1223 Exit_error err_no_source_in_repo $i
cd445739 1224 fi
2a5f078d 1225
ecba6ad5 1226 # we check md5 here just only to refetch immediately
a4b50627 1227 if good_md5 "$i" && good_size "$i"; then
cd445739
AM
1228 :
1229 elif [ "$FROM_DISTFILES" = 1 ]; then
deccc50e 1230 # wrong md5 from distfiles: remove the file and try again
cd445739 1231 # but only once ...
deccc50e 1232 echo "MD5 sum mismatch. Trying full fetch."
cd445739
AM
1233 FROM_DISTFILES=2
1234 rm -f $target
18a52930 1235 update_shell_title "${GETURI%% *}: $url"
ca2e6c31 1236 ${GETURI} ${OUTFILEOPT} "$target" "$url" || \
33da77c4 1237 if [ "`echo $url | grep -E 'ftp://'`" ]; then
ce40491a 1238 update_shell_title "${GETURI2%% *}: $url"
ca2e6c31 1239 ${GETURI2} ${OUTFILEOPT} "$target" "$url"
cd445739 1240 fi
ecba6ad5 1241 if [ ! -s "$target" ]; then
cd445739 1242 rm -f "$target"
18a52930 1243 update_shell_title "${GETURI%% *}: $url_attic"
ca2e6c31 1244 ${GETURI} ${OUTFILEOPT} "$target" "$url_attic" || \
33da77c4 1245 if [ "`echo $url_attic | grep -E 'ftp://'`" ]; then
ce40491a 1246 update_shell_title "${GETURI2%% *}: $url_attic"
ca2e6c31 1247 ${GETURI2} ${OUTFILEOPT} "$target" "$url_attic"
cd445739
AM
1248 fi
1249 fi
1250 test -s "$target" || rm -f "$target"
1251 fi
cd445739 1252 done
e7fa3b9f
ER
1253 SHELL_TITLE_PREFIX=""
1254
cd445739
AM
1255
1256 if [ "$CHMOD" = "yes" ]; then
a8c9a155 1257 CHMOD_FILES=$(nourl "$@")
cd445739
AM
1258 if [ -n "$CHMOD_FILES" ]; then
1259 chmod $CHMOD_MODE $CHMOD_FILES
1260 fi
1261 fi
cd445739
AM
1262 fi
1263}
1264
1265make_tagver() {
ce40491a 1266 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1267 set -x
1268 set -v
ce40491a 1269 fi
78eab2a1 1270
ce40491a
ER
1271 # Check whether first character of PACKAGE_NAME is legal for tag name
1272 if [ -z "${PACKAGE_NAME##[_0-9]*}" -a -z "$TAG_PREFIX" ]; then
1273 TAG_PREFIX=tag_
1274 fi
d712cc12
ER
1275
1276 # NOTE: CVS tags may must not contain the characters `$,.:;@'
392187d9 1277 TAGVER=$(echo $TAG_PREFIX$PACKAGE_NAME-$PACKAGE_VERSION-$PACKAGE_RELEASE | tr '[.@]' '[_#]')
d712cc12 1278
ce40491a
ER
1279 # Remove #kernel.version_release from TAGVER because tagging sources
1280 # could occur with different kernel-headers than kernel-headers used at build time.
d712cc12
ER
1281 # besides, %{_kernel_ver_str} is not expanded.
1282
1283 # TAGVER=auto-ac-madwifi-ng-0-0_20070225_1#%{_kernel_ver_str}
1284 # TAGVER=auto-ac-madwifi-ng-0-0_20070225_1
1285
1286 TAGVER=${TAGVER%#*}
ce40491a 1287 echo -n "$TAGVER"
cd445739
AM
1288}
1289
f6711e2a 1290tag_files() {
cd445739
AM
1291 TAG_FILES="$@"
1292
1293 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1294 set -x
1295 set -v
cd445739
AM
1296 fi
1297
73ef63d8
ER
1298 echo "Version: $PACKAGE_VERSION"
1299 echo "Release: $PACKAGE_RELEASE"
cd445739 1300
a18a9761 1301 local TAGVER
73ef63d8 1302 if [ "$TAG_VERSION" = "yes" ]; then
a18a9761 1303 TAGVER=`make_tagver`
48ab9915 1304 echo "tag: $TAGVER"
73ef63d8
ER
1305 fi
1306 if [ -n "$TAG" ]; then
48ab9915 1307 echo "tag: $TAG"
73ef63d8 1308 fi
cd445739 1309
39dcc7de 1310 local OPTIONS="tag $CVS_FORCE"
cd445739 1311
c713aac3
AG
1312 local _tag=$TAG
1313 if [ "$TAG_VERSION" = "yes" ]; then
1314 _tag=$TAGVER
1315 fi;
c713aac3 1316
9c909460 1317 cd "$PACKAGE_DIR"
03db3356 1318
73ef63d8 1319 if [ "$TAG_VERSION" = "yes" ]; then
48ab9915
KK
1320 update_shell_title "tag sources: $TAGVER"
1321 git $OPTIONS $TAGVER || exit
d066a981 1322 git push $CVS_FORCE $REMOTE_PLD tag $TAGVER || Exit_error err_remote_problem $REMOTE_PLD
73ef63d8
ER
1323 fi
1324 if [ -n "$TAG" ]; then
48ab9915
KK
1325 update_shell_title "tag sources: $TAG"
1326 git $OPTIONS $TAG $chunk || exit
d066a981 1327 git push $CVS_FORCE $REMOTE_PLD tag $TAG || Exit_error err_remote_problem $REMOTE_PLD
73ef63d8 1328 fi
cd445739
AM
1329}
1330
f6711e2a 1331branch_files() {
cd445739 1332 TAG=$1
f663f264 1333 echo "Git branch: $TAG"
518ff1fb 1334 shift
cd445739 1335
cd445739 1336 if [ -n "$DEBUG" ]; then
518ff1fb
ER
1337 set -x
1338 set -v
cd445739
AM
1339 fi
1340
f663f264 1341 local OPTIONS="branch $CVS_FORCE"
c10fa4fa 1342
9c909460 1343 cd "$PACKAGE_DIR"
f663f264 1344 git $OPTIONS $TAG || exit
cd445739
AM
1345}
1346
1347
3009b80d
ER
1348# this function should exit early if package can't be built for this arch
1349# this avoids unneccessary BR filling.
1350check_buildarch() {
1351 local out ret
13c3c336 1352 out=$(minirpm --short-circuit -bp --define "'prep exit 0'" --nodeps $SPECFILE 2>&1)
3009b80d
ER
1353 ret=$?
1354 if [ $ret -ne 0 ]; then
1355 echo >&2 "$out"
1356 exit $ret
1357 fi
1358}
1359
9d99a240
ER
1360# from relup.sh
1361set_release() {
1362 local specfile="$1"
1363 local rel="$2"
1364 local newrel="$3"
1365 sed -i -e "
1366 s/^\(%define[ \t]\+_\?rel[ \t]\+\)$rel\$/\1$newrel/
1367 s/^\(Release:[ \t]\+\)$rel\$/\1$newrel/
1368 " $specfile
1369}
1370
1371set_version() {
1372 local specfile="$1"
bc8502e6
ER
1373 local ver="$2" subver=$ver
1374 local newver="$3" newsubver=$newver
1375
1376 # try handling subver, everything that's not numeric-dotted in version
1377 if grep -Eq '%define\s+subver' $specfile; then
1378 subver=$(echo "$ver" | sed -re 's,^[0-9.]+,,')
1379 ver=${ver%$subver}
1380 newsubver=$(echo "$newver" | sed -re 's,^[0-9.]+,,')
1381 newver=${newver%$newsubver}
1382 fi
9d99a240
ER
1383 sed -i -e "
1384 s/^\(%define[ \t]\+_\?ver[ \t]\+\)$ver\$/\1$newver/
bc8502e6 1385 s/^\(%define[ \t]\+subver[ \t]\+\)$subver\$/\1$newsubver/
9d99a240
ER
1386 s/^\(Version:[ \t]\+\)$ver\$/\1$newver/
1387 " $specfile
1388}
1389
cacef28c 1390try_upgrade() {
cd445739 1391 if [ -n "$TRY_UPGRADE" ]; then
9d99a240 1392 local TNOTIFY TNEWVER TOLDVER
ce40491a 1393 update_shell_title "build_package: try_upgrade"
9d99a240 1394
cacef28c 1395 cd "$PACKAGE_DIR"
1396
0907f1eb
ER
1397 if [ "$UPGRADE_VERSION" ]; then
1398 TNEWVER=$UPGRADE_VERSION
cd445739 1399 else
0907f1eb
ER
1400 if [ -n "$FLOAT_VERSION" ]; then
1401 TNOTIFY=$($APPDIR/pldnotify.awk ${BE_VERBOSE:+-vDEBUG=1} $SPECFILE -n) || exit 1
1402 else
1403 TNOTIFY=$($APPDIR/pldnotify.awk ${BE_VERBOSE:+-vDEBUG=1} $SPECFILE) || exit 1
1404 fi
cd445739 1405
b9bef5ce
ER
1406 # pldnotify.awk does not set exit codes, but it has match for ERROR
1407 # in output which means so.
1408 if [[ "$TNOTIFY" = *ERROR* ]]; then
1409 echo >&2 "$TNOTIFY"
1410 exit 1
1411 fi
1412
0907f1eb
ER
1413 TNEWVER=$(echo $TNOTIFY | awk '{ match($4,/\[NEW\]/); print $5 }')
1414 fi
cd445739
AM
1415
1416 if [ -n "$TNEWVER" ]; then
1417 TOLDVER=`echo $TNOTIFY | awk '{ print $3; }'`
9d99a240 1418 echo "New version found, updating spec file from $TOLDVER to version $TNEWVER"
257af81b
ER
1419 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
1420 cp -f $SPECFILE $SPECFILE.bak
1421 fi
cd445739 1422 chmod +w $SPECFILE
cacef28c 1423 set_release $SPECFILE $PACKAGE_RELEASE 1
9d99a240 1424 set_version $SPECFILE $PACKAGE_VERSION $TNEWVER
518ff1fb 1425 parse_spec
6decb793
ER
1426 if [ "$PACKAGE_VERSION" != "$TNEWVER" ]; then
1427 echo >&2 "Upgrading version failed, you need to update spec yourself"
1428 exit 1
1429 fi
cacef28c 1430 return 1
cd445739
AM
1431 fi
1432 fi
cacef28c 1433 return 0
1434}
1435
1436build_package() {
1437 update_shell_title "build_package"
1438 if [ -n "$DEBUG" ]; then
1439 set -x
1440 set -v
1441 fi
1442
9c909460 1443 cd "$PACKAGE_DIR"
2a5f078d 1444
cd445739
AM
1445 case "$COMMAND" in
1446 build )
1447 BUILD_SWITCH="-ba" ;;
1448 build-binary )
1449 BUILD_SWITCH="-bb" ;;
1450 build-source )
1451 BUILD_SWITCH="-bs --nodeps" ;;
1452 build-prep )
1453 BUILD_SWITCH="-bp --nodeps" ;;
6594293d
AG
1454 build-build )
1455 BUILD_SWITCH="-bc" ;;
1456 build-install )
1457 BUILD_SWITCH="-bi" ;;
1458 build-list )
1459 BUILD_SWITCH="-bl" ;;
1460
cd445739 1461 esac
c890b916 1462
2e5be021 1463 update_shell_title "build_package: $COMMAND"
cd445739
AM
1464 if [ -n "$LOGFILE" ]; then
1465 LOG=`eval echo $LOGFILE`
1466 if [ -d "$LOG" ]; then
1467 echo "Log file $LOG is a directory."
1468 echo "Parse error in the spec?"
518ff1fb 1469 Exit_error err_build_fail
cd445739
AM
1470 fi
1471 if [ -n "$LASTLOG_FILE" ]; then
1472 echo "LASTLOG=$LOG" > $LASTLOG_FILE
1473 fi
390d081d 1474 RES_FILE=$(tempfile)
8cc8f5c0 1475 local specfile=$(insert_gitlog $SPECFILE)
525bf240 1476
8cc8f5c0 1477 (time eval ${NICE_COMMAND} $RPMBUILD $TARGET_SWITCH $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND --define \'_specdir $PACKAGE_DIR\' --define \'_sourcedir $PACKAGE_DIR\' $specfile; echo $? > $RES_FILE) 2>&1 |tee $LOG
cd445739 1478 RETVAL=`cat $RES_FILE`
8cc8f5c0 1479 rm $RES_FILE $specfile
cd445739
AM
1480 if [ -n "$LOGDIROK" ] && [ -n "$LOGDIRFAIL" ]; then
1481 if [ "$RETVAL" -eq "0" ]; then
1482 mv $LOG $LOGDIROK
1483 else
1484 mv $LOG $LOGDIRFAIL
1485 fi
1486 fi
8ba5cdda 1487 else
9c909460 1488 eval ${NICE_COMMAND} $RPMBUILD $TARGET_SWITCH $BUILD_SWITCH -v $QUIET $CLEAN $RPMOPTS $RPMBUILDOPTS $BCOND --define \'_specdir $PACKAGE_DIR\' --define \'_sourcedir $PACKAGE_DIR\' $SPECFILE
cd445739 1489 RETVAL=$?
8ba5cdda 1490 fi
cd445739
AM
1491 if [ "$RETVAL" -ne "0" ]; then
1492 if [ -n "$TRY_UPGRADE" ]; then
cacef28c 1493 echo "\nUpgrade package to new version failed."
257af81b 1494 if [ "$REVERT_BROKEN_UPGRADE" = "yes" ]; then
cacef28c 1495 echo "Restoring old spec file."
257af81b
ER
1496 mv -f $SPECFILE.bak $SPECFILE
1497 fi
cacef28c 1498 echo ""
cd445739 1499 fi
518ff1fb 1500 Exit_error err_build_fail
cd445739
AM
1501 fi
1502 unset BUILD_SWITCH
1503}
1504
f6711e2a 1505nourl() {
cd445739
AM
1506 echo "$@" | sed 's#\<\(ftp\|http\|https\|cvs\|svn\)://[^ ]*/##g'
1507}
1508
f6711e2a 1509install_required_packages() {
cd445739
AM
1510 run_poldek -vi $1
1511 return $?
1512}
1513
f6711e2a 1514find_spec_bcond() { # originally from /usr/lib/rpm/find-spec-bcond
fa4bf1df 1515 local SPEC="$1"
fa4bf1df
ER
1516 awk -F"\n" '
1517 /^%changelog/ { exit }
fa4bf1df
ER
1518 /^%bcond_with/{
1519 match($0, /bcond_with(out)?[ \t]+[_a-zA-Z0-9]+/);
8ff97f39
ER
1520 bcond = substr($0, RSTART + 6, RLENGTH - 6);
1521 gsub(/[ \t]+/, "_", bcond);
fa4bf1df
ER
1522 print bcond
1523 }' $SPEC | LC_ALL=C sort -u
1524}
1525
117d9861 1526process_bcondrc() {
301cbfd4
ER
1527 # expand bconds from ~/.bcondrc
1528 # The file structure is like gentoo's package.use:
1529 # ---
1530 # * -selinux
1531 # samba -mysql -pgsql
47a8df12 1532 # w32codec-installer license_agreement
301cbfd4
ER
1533 # php +mysqli
1534 # ---
fa4bf1df 1535 if ([ -f $HOME/.bcondrc ] || ([ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ])); then
117d9861
ER
1536 :
1537 else
1538 return
1539 fi
301cbfd4 1540
117d9861 1541 SN=${SPECFILE%%\.spec}
c8a3e2ac 1542
117d9861
ER
1543 local bcondrc=$HOME/.bcondrc
1544 [ -n $HOME_ETC ] && [ -f $HOME_ETC/.bcondrc ] && bcondrc=$HOME_ETC/.bcondrc
301cbfd4 1545
117d9861 1546 local bcond_avail=$(find_spec_bcond $SPECFILE)
301cbfd4 1547
117d9861
ER
1548 while read pkg flags; do
1549 # ignore comments
1550 [[ "$pkg" == \#* ]] && continue
1551
1552 # any package or current package?
1553 if [ "$pkg" = "*" ] || [ "$pkg" = "$PACKAGE_NAME" ] || [ "$pkg" = "$SN" ]; then
1554 for flag in $flags; do
1555 local opt=${flag#[+-]}
1556
1557 # use only flags which are in this package.
1558 if [[ $bcond_avail = *${opt}* ]]; then
1559 if [[ $flag = -* ]]; then
1560 if [[ $BCOND != *--with?${opt}* ]]; then
1561 BCOND="$BCOND --without $opt"
1562 fi
1563 else
1564 if [[ $BCOND != *--without?${opt}* ]]; then
1565 BCOND="$BCOND --with $opt"
301cbfd4
ER
1566 fi
1567 fi
117d9861
ER
1568 fi
1569 done
1570 fi
1571 done < $bcondrc
1572 update_shell_title "parse ~/.bcondrc: DONE!"
1573}
1574
8ff97f39 1575set_bconds_values() {
117d9861
ER
1576 update_shell_title "set bcond values"
1577
1578 AVAIL_BCONDS_WITHOUT=""
1579 AVAIL_BCONDS_WITH=""
8ff97f39 1580
5a28189c 1581 if grep -Eq '^# *_with' ${SPECFILE}; then
8ff97f39
ER
1582 echo >&2 "ERROR: This spec has old style bconds."
1583 exit 1
1584 fi
1585
1586 if ! grep -q '^%bcond' ${SPECFILE}; then
117d9861 1587 return
301cbfd4
ER
1588 fi
1589
117d9861
ER
1590 local bcond_avail=$(find_spec_bcond $SPECFILE)
1591 process_bcondrc "$SPECFILE"
1592
fa4bf1df 1593 update_shell_title "parse bconds"
2a5f078d 1594
8ff97f39
ER
1595 local opt bcond
1596 for opt in $bcond_avail; do
1597 case "$opt" in
1598 without_*)
1599 bcond=${opt#without_}
10d92f71
ER
1600 case "$BCOND" in
1601 *--without?${bcond}*)
8ff97f39 1602 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT <$bcond>"
10d92f71
ER
1603 ;;
1604 *)
8ff97f39 1605 AVAIL_BCONDS_WITHOUT="$AVAIL_BCONDS_WITHOUT $bcond"
10d92f71
ER
1606 ;;
1607 esac
cd445739 1608 ;;
8ff97f39
ER
1609 with_*)
1610 bcond=${opt#with_}
10d92f71
ER
1611 case "$BCOND" in
1612 *--with?${bcond}*)
8ff97f39 1613 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH <$bcond>"
10d92f71
ER
1614 ;;
1615 *)
8ff97f39 1616 AVAIL_BCONDS_WITH="$AVAIL_BCONDS_WITH $bcond"
10d92f71
ER
1617 ;;
1618 esac
cd445739 1619 ;;
8ff97f39
ER
1620 *)
1621 echo >&2 "ERROR: unexpected '$opt' in set_bconds_values"
1622 exit 1
1623 ;;
1624 esac
1625 done
cd445739
AM
1626}
1627
f6711e2a 1628run_sub_builder() {
cd445739 1629 package_name="${1}"
af6b168f 1630 update_shell_title "run_sub_builder $package_name"
cd445739
AM
1631 #
1632